/*
 * Character.cpp
 *
 *  Created on: 24/mar/2014
 *      Author: studente
 */

#include "Character.h"
#include <iostream>

#include "Dice.h"

Character::Character(int hp, int l, int a, int x, int y) {
	this->hp = hp;
	level = l;
	armor = a;
	posX = x;
	posY = y;
	name = "";
	weapon = 0;
}

Character::Character(std::string n, int hp, int l) {
	name = n;
	this->hp = hp;
	level = l;
	posX = 0;
	posY = 0;
	armor = 1;
	weapon = 0;
}

Character::~Character() {
	if (weapon) {
		delete weapon;
		std::cout << "Deleted weapon" << std::endl;
	}
}

/*
void Character::move(int x, int y) {
	posX = x;
	posY = y;
	std::cout << "Pos: " << posX << " - " << posY << std::endl;
}

int Character::fight(Character& enemy) {
	Dice aDice(4);
	int hit = aDice.throwDice() * level;
	if (hit > enemy.level) {
		if (!weapon)
			return 1; // bare hand fight: mimimum damage
		int damage = weapon->useWeapon(); // FIXME
		enemy.setHp(enemy.hp - damage);
		return damage;
	} else {
		std::cout << "Missed hit !" << std::endl;
		return 0; // missed hit: no damage
	}
}
*/

int Character::getArmor() const {
	return armor;
}

void Character::setArmor(int armor) {
	this->armor = armor;
}

int Character::getHp() const {
	return hp;
}

void Character::setHp(int hp) {
	this->hp = hp;
	if (this->hp < 0)
		std::cout << name << " is dead !" << std::endl;
}

int Character::getLevel() const {
	return level;
}

void Character::setLevel(int level) {
	this->level = level;
}

const std::string& Character::getName() const {
	return name;
}

void Character::setName(const std::string& name) {
	this->name = name;
}

const Weapon* Character::getWeapon() const {
	return weapon;
}

void Character::setWeapon(Weapon* weapon) {
	this->weapon = weapon;
}
