/*
 * game.cpp
 *
 *  Created on: 24/mar/2014
 *      Author: bertini
 */

#include <iostream>

#include "Character.h"
#include "Knight.h"
#include "Wizard.h"
#include "Monster.h"
#include "Sword.h"
#include "Fang.h"
#include "Tile.h"
#include "GameMap.h"

int main() {
	GameMap* map1 = new GameMap(2,2);
	Tile t1(1,true);
	Tile t2(2, false);
	Tile t3(3, true);
	Tile t4(4, false);
	map1->setTile(0, 0, t1);
	map1->setTile(0, 1, t2);
	map1->setTile(1, 0, t3);
	map1->setTile(1, 1, t4);
	GameMap map2(*map1);
	delete map1;
	map2.printMap();

	Weapon* sword = new Weapon(3);
	Character* hero = new Knight("Boromir", 36, 1, 6);
	hero->setWeapon(sword);

	Character* hero2 = new Wizard("Gandalf", 30, 2, 6);

	const int numPlayers = 2;
	Character* heroTeam[numPlayers];
	heroTeam[0] = hero;
	heroTeam[1] = hero2;

	Weapon* fang = new Fang(3, false);
	Character* orc = new Monster(30, 1, 1);
	orc->setWeapon(fang);
	orc->setName("orc");

	for (int i = 0; i < numPlayers; i++) {
		Wizard* wizardHero = dynamic_cast<Wizard*>(heroTeam[i]);
		if (wizardHero) {
			wizardHero->doMagic(*orc);
		} else {
			int damage = heroTeam[i]->fight(*orc);
			if (damage)
				std::cout << heroTeam[i]->getName() << " hits the orc - damage: " << damage
						<< " points" << std::endl;

			Weapon* magicSword = new Sword(7, true);
			heroTeam[i]->setWeapon(magicSword);
			damage = heroTeam[i]->fight(*orc);
			if (damage)
				std::cout << heroTeam[i]->getName() << " hits the orc - damage: " << damage
						<< " points" << std::endl;
		}
	}


	delete hero;
	delete hero2;
	delete orc;
}
